; mStats (mIRC Stats)
;  by John Endicott (aka Teenman)
alias mstats.start {
  socklisten mstats.listen $iif($1,$1,1337)
}
alias mstats.stop { sockclose mstats.listen }
alias mstats.status { return $iif($sock(mstats.listen),active,disabled) }
alias mstats.ini {
  if ($isid) {
    return $readini($+($chr(34),$scriptdir,$1,$chr(34)),$2,$3)
  }
  else { run notepad $+($chr(34),$scriptdir,$1,$chr(34)) }
}
alias mstats.write {
  writeini $+($chr(34),$scriptdir,$1,$chr(34)) $2-
}
on *:SOCKLISTEN:mstats.listen:{
  set %temp 1
  while ($sock(mstats. $+ $calc($sock(*,0) + %temp))) { inc %temp }
  sockaccept mstats. $+ $calc($sock(*,0) + %temp)
}
on *:SOCKREAD:mstats.*:{
  sockread %mstats.read
  tokenize 32 %mstats.read
  if ($1 == GET) {
    mstats.send $sockname
  }
}
alias -l mstats.replace {
  set %mstats.replace $1-
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),ops,$chr(37)),$mstats.ini(general.ini,totals,ops))
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),joins,$chr(37)),$mstats.ini(general.ini,totals,joins))
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),kicks,$chr(37)),$mstats.ini(general.ini,totals,kicks))
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),bans,$chr(37)),$mstats.ini(general.ini,totals,bans))
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),voices,$chr(37)),$mstats.ini(general.ini,totals,voices))
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),topic,$chr(37)),$mstats.ini(general.ini,current,topic))
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),users,$chr(37)),$mstats.ini(general.ini,current,users))
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),modes,$chr(37)),$mstats.ini(general.ini,current,modes))
  set %mstats.replace $replace(%mstats.replace,$+($chr(37),chantitle,$chr(37)),$mstats.ini(general.ini,config,chantitle))
  return %mstats.replace
}

alias -l mstats.send {
  set %mstats.stats 1
  while (%mstats.stats <= $lines($+($chr(34),$scriptdir,stats.html,$chr(34)))) {
    sockwrite -n $1 $mstats.replace($read($+($chr(34),$scriptdir,stats.html,$chr(34)),%mstats.stats)))
    inc %mstats.stats
  }
  sockclose $1
}
on *:TOPIC:*:{
  if ($chan == $mstats.ini(general.ini,config,channel)) {
    mstats.write general.ini current topic $chan($chan).topic
  }
}
on *:JOIN:*:{
  if ($chan == $mstats.ini(general.ini,config,channel)) {
    mstats.write general.ini totals joins $calc($mstats.ini(general.ini,totals,joins) + 1)
    mstats.write general.ini current users $nick($chan,0)
  }
}
on *:OP:*:{
  if ($chan == $mstats.ini(general.ini,config,channel)) {
    mstats.write general.ini totals ops $calc($mstats.ini(general.ini,totals,ops) + 1)
  }
}
on *:VOICE:*:{
  if ($chan == $mstats.ini(general.ini,config,channel)) {
    mstats.write general.ini totals voices $calc($mstats.ini(general.ini,totals,voices) + 1)
  }
}
on *:BAN:*:{
  if ($chan == $mstats.ini(general.ini,config,channel)) {
    mstats.write general.ini totals bans $calc($mstats.ini(general.ini,totals,bans) + 1)
  }
}
on *:KICK:*:{
  if ($chan == $mstats.ini(general.ini,config,channel)) {
    mstats.write general.ini totals kicks $calc($mstats.ini(general.ini,totals,kicks) + 1)
    mstats.write general.ini current users $nick($chan,0)
  }
}
on *:MODE:*:{
  if ($chan == $mstats.ini(general.ini,config,channel)) {
    mstats.write general.ini current modes $1-
  }
}
